# version 300 es
precision highp float;
in vec4 v_color;
in vec2 v_texCoords;

uniform sampler2D u_texture;
uniform vec2 u_resolution;
uniform vec2 u_location;
uniform float u_width;
uniform float u_height;
uniform float u_progress;
uniform vec4 u_lineColor;
uniform float u_isturn;
out vec4 fragColor;
void main() {
    vec4 defaultColor = v_color * texture(u_texture, v_texCoords);
    //gl_FragCoord.xy = gl_FragCoord.yx;
    if (u_isturn == 1.) {
        vec2 relativePosition =  gl_FragCoord.xy / u_resolution.xy  - u_location.xy;
        relativePosition /= vec2(u_height , u_width);
        relativePosition.x *= u_resolution.x / u_resolution.y;
        float width = relativePosition.y;
        float lineHeight = .09;
        //vec4 iColor = mix(u_lineColor, u_lineColor2, smoothstep(relativePosition.y - (0.2 * relativePosition.y),relativePosition.y,u_progress));
        vec4 iColor = u_lineColor;
        float w = .01;
        float c = smoothstep(u_progress + w, u_progress - w, width);
        c -= smoothstep(lineHeight/2. - w,lineHeight/2. + w,abs(relativePosition.x));
        fragColor = mix(iColor, defaultColor, clamp(1. -c, 0., 1.));
    } else {
        fragColor = defaultColor;
    }

    //vec2 relativePosition = gl_FragCoord.xy/20.0 - u_location;
    //    vec2 relativePosition = u_location.xy;
    /*

    float width = relativePosition.x;
    float lineHeight = .07 ;
    //float endwidth = u_progress * u_width;
    //vec4 iColor = mix(u_lineColor, u_lineColor2, smoothstep(width - .1 * u_width, width, endwidth));

    //float d = relativePosition.x;
    float w = .01;
    float c = smoothstep(u_progress + w, u_progress - w, width);
    c -= smoothstep(w, -7 * w, relativePosition.y);
    c -= smoothstep(0., 7 * w, relativePosition.y);
    c -= smoothstep(lineHeight/2. - w,lineHeight/2. + w,abs(relativePosition.y));
    //c -= smoothstep(-1. * lineHeight/2. -w, -1* lineHeight/2. + w, relativePosition.y);
    //c -= smoothstep();
    fragColor = mix(iColor, defaultColor, clamp(1. - c, 0., 1.));*/

    //fragColor = vec4(vec3(relativePosition.x),1.);
    //fragColor = vec4(vec3(relativePosition.x), 1.);
}