# version 300 es
precision highp float;
in vec4 v_color;
in vec2 v_texCoords;

uniform sampler2D u_texture;
uniform vec2 u_resolution;
uniform vec2 u_location;
uniform float u_radius;

out vec4 fragColor;
void main() {
    vec2 relativePosition = gl_FragCoord.xy / u_resolution  - u_location.xy;
    //vec2 relativePosition = gl_FragCoord.xy/20.0 - u_location;
    //    vec2 relativePosition = u_location.xy;
    relativePosition.x *= u_resolution.x / u_resolution.y;
    fragColor = v_color * texture(u_texture, v_texCoords);

    float d = length(relativePosition);

    float w = fwidth(d) * 1.0;

    fragColor.a  = mix(0., 1., smoothstep(u_radius , u_radius - .5 * w, d));
}