# version 300 es
precision highp float;
in vec4 v_color;
in vec2 v_texCoords;

uniform sampler2D u_texture;
uniform vec2 u_resolution;
uniform vec2 u_location;
const float PI=3.14159265358979323846;
const float TAU = 6.28318530717958647692;
const float STEP_LENGTH = 0.01;
const float ANGLE_OFFSET = PI*0.5;			// angle of dial
uniform vec4 u_ringColor/* = vec4(0.0, 1.0, 0.0, 1.0)*/;
const float duration = 15.0;
uniform float u_progress;
uniform float u_outerRadius;
uniform float u_innerRadius;

out vec4 fragColor;
void main() {
    vec2 relativePosition = gl_FragCoord.xy / u_resolution  - u_location.xy;
    //vec2 relativePosition = gl_FragCoord.xy/20.0 - u_location;
    //    vec2 relativePosition = u_location.xy;
    relativePosition.x *= u_resolution.x / u_resolution.y;
    vec4 defaultColor = v_color * texture(u_texture, v_texCoords);
    float innerRadius = u_innerRadius;
    float outerRadius = u_outerRadius;
    float startAngle = 0.0;
    float endAngle = u_progress* TAU;

    float d = length(relativePosition);

    float w = fwidth(d) * 1.0;

    float angle = -(atan(relativePosition.y,relativePosition.x)) + ANGLE_OFFSET;
    if( angle < 0.0 ) angle += PI * 2.0;
    float c = smoothstep( outerRadius + w, outerRadius - w, d );
    c -= smoothstep( innerRadius + w, innerRadius - w, d );
    vec4 iColor = u_ringColor;
    fragColor = mix(iColor, defaultColor, 1. -c);

    if( angle < endAngle){
        float a = smoothstep( 0.05, -w*2.0,  abs(endAngle - angle) );
        fragColor.rgb *= a;
        fragColor += defaultColor;
    }
    if(angle - w*2.0 < startAngle ){
        float a = smoothstep(  -w*2.0, w*2.0, (abs(startAngle - angle)) );
        fragColor.rgb *= a;
        fragColor += defaultColor;
    }


    //gl_FragColor = mix(gl_FragColor, u_ringColor2, smoothstep(endAngle * .9, endAngle * 1.1,endAngle));


    fragColor.a = defaultColor.a;
}